<?php

// Reminder: always indent with 4 spaces (no tabs). 
// +---------------------------------------------------------------------------+
// | Archive plugin 1.0 for Geeklog                                            |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// |                                                                           |
// | This is the administration page for the                                   |
// | Archive plugin for Geeklog.                                               |
// +---------------------------------------------------------------------------+
// | Based on the Universal Plugin and prior work by the following authors:    |
// |                                                                           |
// | Copyright (C) 2002-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Euan McKay        - info AT heatherengineering DOT com           |
// |          Tony Bibbs        - tony AT tonybibbs DOT com                    |
// |          Tom Willett       - tom AT pigstye DOT net                       |
// |          Blaine Lang       - blaine AT portalparts DOT com                |
// |          Dirk Haun         - dirk AT haun-online DOT de                   |
// |          Vincent Furia     - vinny01 AT users DOT sourceforge DOT net     |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once ('../../../lib-common.php');
require_once ('../../auth.inc.php');

$display = '';

if (!SEC_hasRights ('archive.edit')) {
    $display .= COM_siteHeader ('menu', $MESSAGE[30]);
    $display .= COM_startBlock ($MESSAGE[30], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
    $display .= $MESSAGE[34];
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter ();
    COM_accessLog ("User {$_USER['username']} tried to illegally access the Archive administration screen.");
    echo $display;
    exit;
}

/**
* Shows the archive admin page
*
* @return string HTML for the link editor form
*
*/
function archive_admin_show_settings () 
{
    global $_CONF, $_TABLES, $_USER, $LANG_AR_ADMIN;

    $retval = '';

    // Set template and basic strings
    $T = new Template($_CONF['path'] . 'plugins/archive/templates/admin/');
    $T->set_file('page','index.thtml');
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);
    $T->set_var('layout_url',$_CONF['layout_url']);
    
    // Get settings from database
    // Get field values
    $loggedin = DB_GetItem($_TABLES['groups'], 'grp_id', "grp_name='Logged-in Users'");
    $archiveft = DB_GetItem($_TABLES['features'], 'ft_id', "ft_name='archive.edit'");

    // Get existing settings
    $return = DB_Query("SELECT COUNT(*) FROM {$_TABLES['access']} WHERE acc_ft_id='$archiveft' AND acc_grp_id='$loggedin'");
    $count = DB_FetchArray($return);

    // Start page
    $retval .= COM_startBlock ($LANG_AR_ADMIN[1], '',
                               COM_getBlockTemplate ('_admin_block', 'header'));

    // Prepare data for form
    if ($count[0]>0) {
        $allow = "CHECKED";
    } else {
        $allow = '';
    }

    // Set data to form
    $T->set_var('allow_value', $allow);
    
    // Set language strings to form
    $T->set_var('allow_lang', $LANG_AR_ADMIN['allowloggedin']);
    $T->set_var('lang_save', $LANG_AR_ADMIN['save']);
    $T->set_var('lang_cancel', $LANG_AR_ADMIN['cancel']);

    // Parse output
    $T->parse('output', 'page');
    $retval .= $T->finish($T->get_var('output'));

    // Finish up page
    $retval .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));

    // Return HTML to caller
    return $retval;
}



/**
* Saves archive admin settings to the database
*
* @param    string  $allow          whether to allow logged in users access
* @return   string                  HTML redirect or error message
* @global array core config vars
* @global array core table data
* @global array core user data
* @global array core msg data
* @global array archive plugin lang admin vars
*
*/
function archive_admin_save_settings ($allow)
{
    global $_CONF, $_TABLES, $LANG_AR_ADMIN;

    $retval = '';

//    // Convert array values to numeric permission values
//    if (is_array($perm_owner) OR is_array($perm_group) OR is_array($perm_members) OR is_array($perm_anon)) {
//        list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($perm_owner,$perm_group,$perm_members,$perm_anon);
//    }

    // Get field values
    $loggedin = DB_GetItem($_TABLES['groups'], 'grp_id', "grp_name='Logged-in Users'");
    $archiveft = DB_GetItem($_TABLES['features'], 'ft_id', "ft_name='archive.edit'");

    // Get existing settings
    $return = DB_Query("SELECT COUNT(*) FROM {$_TABLES['access']} WHERE acc_ft_id='$archiveft' AND acc_grp_id='$loggedin'");
    $count = DB_FetchArray($return);

    if ($count[0]>0 && !$allow) {
        // Deleted rights, so update settings
        $result = DB_Query("DELETE FROM {$_TABLES['access']} WHERE (acc_ft_id=$archiveft AND acc_grp_id=$loggedin) LIMIT 1");
    } elseif ($count[0]<1 && $allow) {
        // Set rights
        DB_Save($_TABLES['access'], 'acc_ft_id,acc_grp_id', "'$archiveft','$loggedin'");
    }

    return COM_refresh ($_CONF['site_admin_url'] . '/plugins/archive/index.php?msg=7');

}




// +---------------------------------------------------------------------------+
// | Main                                                                      |
// +---------------------------------------------------------------------------+

$mode = '';
if (isset ($_REQUEST['mode'])) {
    $mode = $_REQUEST['mode'];
}
$allow = '';
if (isset ($_REQUEST['allow'])) {
    $allow = $_REQUEST['allow'];
}

//echo "<pre>";
//print_r($_REQUEST);
//echo "</pre>";


//echo "<br>".$allow."<br>";
//exit;

// case save settings **********************************************************

if (($mode == $LANG_ADMIN['save']) && !empty ($LANG_ADMIN['save'])) {
    $display .= archive_admin_save_settings ($allow);


// 'cancel' or no mode at all **************************************************

} else {
    $display .= COM_siteHeader ('menu', $LANG_AR_ADMIN[11]);
    if (isset ($_REQUEST['msg'])) {
        $msg = COM_applyFilter ($_REQUEST['msg'], true);
        if ($msg > 0) {
            $display .= COM_showMessage ($msg, 'archive');
        }
    }
    $display .= archive_admin_show_settings();
    $display .= COM_siteFooter ();
}


// display page ****************************************************************

echo $display;

?>