<?php

// Reminder: always indent with 4 spaces (no tabs). 
// +---------------------------------------------------------------------------+
// | Archive plugin 1.0 for Geeklog                                            |
// +---------------------------------------------------------------------------+
// | config.php                                                                |
// |                                                                           |
// | Configuration file for the Geeklog Archive Plugin                         |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2000-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Euan McKay        - info AT heatherengineering DOT com           |
// |          Tony Bibbs        - tony AT tonybibbs DOT com                    |
// |          Mark Limburg      - mlimburg AT users.sourceforge DOT net        |
// |          Jason Whittenburg - jwhitten AT securitygeeks DOT com            |
// |          Dirk Haun         - dirk AT haun-online DOT de                   |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is licensed under the terms of the GNU General Public License|
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      |
// | See the GNU General Public License for more details.                      |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+


/**
* the archive plugin's config aray
* 
* @global array $_GN_CONF 
*/
$_AR_CONF = array();

/**
* the archive plugin's version setting
* 
* @global array $_GN_CONF['version']
*/
$_AR_CONF['version'] = '1.0';          // Plugin Version

/**
 * this lets you select which functions are available for registered users only
 * 
 * @global array $_GN_CONF['archiveloginrequired']
 */ 
$_AR_CONF['archiveloginrequired'] = 0;

/**
 * notify when a new archive was submitted
 * 
 * @global array $_GN_CONF['notification']
 */ 
$_AR_CONF['notification'] = 0; 

/**
 * should we remove archive submited by users if account is removed? (1)
 * or change owner to root (0)
 * 
 * @global array $_GN_CONF['delete_archive']
 */ 
$_AR_CONF['delete_archive'] = 0; 

/**
 * show left menu (1) or hide it (0)
 * 
 * @global array $_GN_CONF['show_left_menu']
 */ 
$_AR_CONF['show_left_menu'] = 0; 

/**
 * enable simple multilanguage support (1) or turn it off (0)
 * 
 * @global array $_GN_CONF['multilanguage_support']
 */ 
$_AR_CONF['multilanguage_support'] = 1; 

/**
 * Define default permissions for new archive created from the Admin panel.
 * Permissions are perm_owner, perm_group, perm_members, perm_anon (in that
 * order). Possible values:<br>
 * - 3 = read + write permissions (perm_owner and perm_group only)
 * - 2 = read-only
 * - 0 = neither read nor write permissions
 * (a value of 1, ie. write-only, does not make sense and is not allowed)
 * 
 * @global array $_GN_CONF['default_permissions']
 */ 
$_AR_CONF['default_permissions'] = array (3, 3, 2, 2);

// database table names - don't change
$_TABLES['archive']               = $_DB_table_prefix . 'archive';
$_TABLES['archive_text']          = $_DB_table_prefix . 'archive_text';
$_TABLES['archive_address']       = $_DB_table_prefix . 'archive_address';
$_TABLES['archive_related']       = $_DB_table_prefix . 'archive_related';

?>