<?php

// PHP for MediaGallery to return albums to include in Archive.
// This creates a simple list of albums to include.

// Not sure about how to go about including individual photos yet.
// Any ideas welcome!


// +---------------------------------------------------------------------------+
// | MediaGallery                                                              |
// +---------------------------------------------------------------------------+

// JUST FOR TESTING!!!!
require_once('../lib-common.php');


/**
* Returns a list of all MediaGallery albums
*/

function archive_make_mediagallery_list()
{
    global $_CONF, $_TABLES, $LANG_AR, $MG_albums, $album_jumpbox;

    // check to see if Media Gallery is installed and active...
    if (!function_exists(MG_usage)) {
        return '';
    }

    $level = 0;
    $album_jumpbox = '<select name="relatedid">';
    $MG_albums[0]->buildJumpBox(0);
    $album_jumpbox .= '</select>';

    return $album_jumpbox;
}



/**
* Returns array of title and link to a MediaGallery given id
*/

function archive_mediagallery_item ($id)
{
    global $_CONF, $_TABLES, $LANG_AR, $MG_albums, $_MG_CONF;

    // check to see if Media Gallery is installed and active...
    if (!function_exists(MG_usage)) {
        return '';
    }
    $retval = '';

    if ( $MG_albums[$id]->access == 0 || ($MG_albums[$id]->hidden == 1 && $MG_albums[$id]->access !=3 )) {
        $retval['title'] = "No such item";
        $retval['link'] = "";
    } else {
        $retval['title'] = $MG_albums[$id]->title;
        $link = $_MG_CONF['site_url'] . "/album.php?aid=".$id;
        $retval['link'] = $link;
    }
   return $retval;
}

function archive_mediagallery_thumbnail( $id )
{
    global $_TABLES, $_MG_CONF;

    // check to see if Media Gallery is installed and active...
    if (!function_exists(MG_usage)) {
        return '';
    }

    $retval = array();

    $sql = "SELECT * FROM {$_TABLES['mg_media']} WHERE media_id=" . $id;
    $result = DB_query( $sql );
    $nRows  = DB_numRows( $result );
    if ( $nRows > 0 ) {
        $M = DB_fetchArray($result);

        switch( $M['media_type'] ) {
            case 0 :    // standard image
                $default_thumbnail = 'tn/' . $M['media_filename'][0] . '/' . $M['media_filename']. '.jpg';
                break;
            case 1 :    // video file
                switch ( $M['media_mime_ext'] ) {
                    case 'swf' :
                        $default_thumbnail = 'flash.gif';
                        break;
                    case 'mov' :
                    case 'mp4' :
                        $default_thumbnail = 'quicktime.gif';
                        break;
                    case 'asf' :
                        $default_thumbnail = 'wmp.gif';
                        break;
                    default :
                        $default_thumbnail = 'video.gif';
                        break;
                }
                break;
            case 2 :    // music file
                $default_thumbnail = 'audio.gif';
                break;
            case 4 :    // other files
                switch ($M['media_mime_ext']) {
                    case 'zip' :
                    case 'arj' :
                    case 'rar' :
                    case 'gz'  :
                        $default_thumbnail = 'zip.gif';
                        break;
                    case 'pdf' :
                        $default_thumbnail = 'pdf.gif';
                        break;
                    default :
                        $default_thumbnail = 'generic.gif';
                        break;
                }
                break;
        }

        if ( $M['media_tn_attached'] == 1 ) {
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/tn/'.  $M['media_filename'][0] . '/tn_' . $M['media_filename'] . '.jpg';
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/tn/'.  $M['media_filename'][0] . '/tn_' . $M['media_filename'] . '.jpg';
        } else {
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/' . $default_thumbnail;
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/' . $default_thumbnail;
        }

        $media_size        = @getimagesize($media_thumbnail_file);

        if ( $media_size == false ) {
            $default_thumbnail    = 'generic.gif';
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/' . $default_thumbnail;
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/' . $default_thumbnail;
            $media_size           = @getimagesize($media_thumbnail_file);
        }
        $tn_height = 100;
        if ( $media_size[0] > $media_size[1] ) {
            $ratio = $media_size[0] / $tn_height;
            $newwidth = $tn_height;
            $newheight = round($media_size[1] / $ratio);
        } else {
            $ratio = $media_size[1] / $tn_height;
            $newheight = $tn_height;
            $newwidth = round($media_size[0] / $ratio);
        }
        $media_dim = 'width="' . $newwidth . '" height="' . $newheight . '"';

        $img = '<img src="' .$media_thumbnail . '" ' . $media_dim . ' border="0" alt="' . strip_tags(COM_stripslashes($M['media_title'])) . '" title="' . strip_tags(COM_stripslashes($M['media_title'])) . '"/>';
        $link = $_MG_CONF['site_url'] . '/media.php?f=0' . '&amp;s=' . $M['media_id'] ;
        $title = strip_tags(COM_stripslashes($M['media_title']));
        $id    = $M['media_id'];
        $retval['id'] = $id;
        $retval['title'] = $title;
        $retval['img'] = $img;
        $retval['link'] = $link;
    } else {
        $retval['id'] = $id;
        $retval['title'] = '';
        $retval['img'] = '';
        $retval['link'] = '';
    }

    return $retval;
}


echo archive_make_mediagallery_list();
echo "<pre>";
print_r( archive_mediagallery_item (95));
print_r( archive_mediagallery_thumbnail('20061128175518895'));
echo "</pre>";

?>