<?php

// Reminder: always indent with 4 spaces (no tabs). 
// +---------------------------------------------------------------------------+
// | Archive plugin 1.0 for Geeklog                                            |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// |                                                                           |
// | This is the main page for the Archive plugin for Geeklog                  |
// +---------------------------------------------------------------------------+
// | Based on the Universal Plugin and prior work by the following authors:    |
// |                                                                           |
// | Copyright (C) 2002-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Euan McKay        - info AT heatherengineering DOT com           |
// |          Tony Bibbs        - tony AT tonybibbs DOT com                    |
// |          Tom Willett       - tom AT pigstye DOT net                       |
// |          Blaine Lang       - blaine AT portalparts DOT com                |
// |          Dirk Haun         - dirk AT haun-online DOT de                   |
// |          Vincent Furia     - vinny01 AT users DOT sourceforge DOT net     |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

require_once ('../lib-common.php');

// echo COM_debug($_POST);
// exit;

$display = '';



// +---------------------------------------------------------------------------+
// | Archive main item functions                                               |
// +---------------------------------------------------------------------------+

// archive_list_items   - list all archives
// archive_show_archive    - show a single archive
// archive_edit_archive    - edit a single archive
// archive_save_archive    - save a single archive
// archive_delete_archive  - delete a single archive


/**
 * List items
 */

function archive_list_items ()
{
    global $_CONF, $_AR_CONF, $_TABLES, $LANG_ADMIN, $LANG_AR, $LANG_ACCESS, $_IMAGE_TYPE;

    $retval = '';

    // Multilanguage support
    if ($_AR_CONF['multilanguage_support']) {
        $sql = COM_getLangSQL('id', 'AND', $_TABLES['archive']);
    } else {
        $sql = '';
    }
    $sql = "SELECT * FROM " . $_TABLES['archive'] . " WHERE (parent='0') ". $sql;

    // Get archives from DB
    $result = DB_query ($sql);

    // Set template variables
    $T = new Template($_CONF['path'] . 'plugins/archive/templates/');
    $T->set_file(array ('list'    => 'archive_list.thtml',
                        'item'    => 'archive_item.thtml'));
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('plugin_name', $LANG_AR['archive']);
    $T->set_var('description', $LANG_AR['archive_list']);

    // Set link to create new archive if has rights
    if (SEC_hasRights('archive.edit')) {
        $url = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit');
        $link = '<a href="' . $url . '" title="' . $LANG_AR['create_archive'] . '">' 
                 . '<img src="'.$_CONF['site_url'] . '/archive/images/add.gif" alt="' . $LANG_AR['create_archive'] . '">'
                 . '</a>';
        $T->set_var('create_archive', $link);
    } else {
        $T->set_var('create_archive', '');
    }

    // Loop through archives
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
            $T->set_var ('archive_title', stripslashes ($A['title']));
            $linefeed = "\r";
            $description =  str_replace($linefeed, "<BR />", stripslashes ($A['description']));
            $T->set_var ('archive_description', PLG_replaceTags($description));
            $T->set_var ('archive_id', $A['id']);
            // Set link to edit archive if has rights
            if (SEC_hasRights('archive.edit')) {
                $url = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit&id='.$A['id']);
                $link = '<a href="' . $url . '" title="' . $LANG_AR['edit'] . '">' 
                         . '<img src="'.$_CONF['site_url'] . '/archive/images/edit.gif">' 
                         . '</a>';
                $deleteurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=delete&type=archive&id='.$A['id']);
                $link .= '<a href="'.$deleteurl.'" title="' . $LANG_AR['delete'] . '">' 
                        . '<img src="'.$_CONF['site_url'] . '/archive/images/delete.gif">' 
                        . '</a>';

                $T->set_var('edit_archive_item', $link);
            } else {
                $T->set_var('edit_archive_item', '');
            }
            $T->parse ('page_content', 'item', true);
        }
   } else {
        $T->set_var ('page_content', $LANG_AR['no_archives']);
    }

// Parse template
    $T->parse('output', 'list');
    $retval = $T->finish($T->get_var('output'));

// Return HTML

    return $retval;

}



/**
* Show an archive
*/

function archive_show_archive ($id)
{
    global $_CONF, $_TABLES, $_USER, $LANG_AR;
    $retval ='';
    
    // Get item data
    $result = DB_query ("SELECT * FROM " . $_TABLES['archive'] . " WHERE (id='".$id."')");
    $A = DB_fetchArray ($result);

    // Check item exists
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        // Item exists, so set language strings to template
        $T = new Template($_CONF['path'] . 'plugins/archive/templates/');
        $T->set_file(array ('page' => 'archive.thtml'));
        $T->set_var('site_url', $_CONF['site_url']);
        $T->set_var('plugin_name', $LANG_AR['archive']);
        $T->set_var('description', $LANG_AR['archive_list']);
        $T->set_var('lang_modified', $LANG_AR['archive_modified']);
        $T->set_var('lang_created', $LANG_AR['archive_created']);

        // Set data to template
        $T->set_var ('archive_title', stripslashes ($A['title']));
        $linefeed = "\r";
        $description =  str_replace($linefeed, "<BR />", stripslashes ($A['description']));
        $T->set_var ('archive_description', PLG_replaceTags($description));
        $T->set_var ('archive_id', $A['id']);
        $T->set_var ('archive_modified', $A['modified']);
        $T->set_var ('archive_created', $A['created']);

        // add link to edit if has rights
        if (SEC_hasRights('archive.edit')) {
            $editurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit&type=archive&id='.$A['id']);
            $link = '<a href="'.$editurl.'" title="' . $LANG_AR['edit'] . '">' 
                    . '<img src="'.$_CONF['site_url'] . '/archive/images/edit.gif">' 
                    . '</a>';
            $deleteurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=delete&type=archive&id='.$A['id']);
            $link .= '<a href="'.$deleteurl.'" title="' . $LANG_AR['delete'] . '">' 
                    . '<img src="'.$_CONF['site_url'] . '/archive/images/delete.gif">' 
                    . '</a>';
            $T->set_var('edit_archive_item', $link);
        } else {
            $T->set_var('edit_archive_item', '');
        }

        // Get associated items
        $T->set_var ('archive_archives', archive_list_archives($id));
        $T->set_var ('archive_texts', archive_list_texts($id));
        $T->set_var ('archive_addresses', archive_list_addresses($id));
        $T->set_var ('archive_related', archive_list_related($id));

        // Set link to parent

        $url = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?id='.$A['parent']);
        $link = '<a href="'.$url.'" title="' . $LANG_AR['archive_parent'] . '">' 
                . '<img src="'.$_CONF['site_url'] . '/archive/images/up.gif">'
                . '</a>';
        $T->set_var ('archive_parent', $link);

        // Parse template
        $T->parse('output', 'page');
        $retval = $T->finish($T->get_var('output'));
    } else {
        // No such item, so return to top page with error message
        return COM_refresh ($_CONF['site_url']. '/archive/index.php?msg=3');
    }
    
    // Return data
    return $retval;
}


/**
* Lists all the child archive items for an archive item
*/
function archive_list_archives ($parent) {
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';

// Get all archives from DB

    $result = DB_query ("SELECT id,title,description FROM ".$_TABLES['archive']." WHERE (parent='".$parent."')");

// Set template variables
    $T = new Template($_CONF['path'] . 'plugins/archive/templates/');
    $T->set_file(array ('list' => 'item_list.thtml',
                        'item' => 'item_item.thtml'));
    $T->set_var('site_url', $_CONF['site_url']);

// Loop through archives
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $T->set_var('lang_archive_archives', $LANG_AR['archive_archives']);
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
            $T->set_var ('archive_title', $A['title']);
            if (strlen($A['description'])>30) {
                $A['description'] = substr($A['description'],0,30)."...";
            }
            $T->set_var ('archive_description', $A['description']);
            $T->set_var ('archive_id', $A['id']);
            // add link to edit if has rights
            if (SEC_hasRights('archive.edit')) {
                $editurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit&type=archive&id='.$A['id']);
                $link = '<a href="'.$editurl.'" title="' . $LANG_AR['edit'] . '">' 
                        . '<img src="'.$_CONF['site_url'] . '/archive/images/edit.gif">' 
                        . '</a>';
                $deleteurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=delete&type=archive&id='.$A['id']);
                $link .= '<a href="'.$deleteurl.'" title="' . $LANG_AR['delete'] . '">' 
                        . '<img src="'.$_CONF['site_url'] . '/archive/images/delete.gif">' 
                        . '</a>';
                $T->set_var('edit_archive_item', $link);
            } else {
                $T->set_var('edit_archive_item', '');
            }
            $T->parse ('archive_archives', 'item', true);
        }
   } else {
       // Set link to create new archive if has rights
        if (SEC_hasRights('archive.edit')) {
            $T->set_var('lang_archive_archives', $LANG_AR['archive_archives']);
            $T->set_var('archive_archives', $LANG_AR['no_child_archives']);
        } else {
            $T->set_var('lang_archive_archives', '');
            $T->set_var('add_archive', '');
            $T->set_var('archive_archives', '');
        }
    }

    if (SEC_hasRights('archive.edit')) {
        $url = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit&type=archive&parent='.$parent);
        $link = '<a href="'.$url.'" title="' . $LANG_AR['add_archive'] . '">' 
                    . '<img src="'.$_CONF['site_url'] . '/archive/images/add.gif">' 
                    . '</a>';
        $T->set_var('add_archive', $link);
    }

// Parse template
    $T->parse('output', 'list');
    $retval = $T->finish($T->get_var('output'));

// Return HTML

    return $retval;
}




/**
* Shows the archive editor
*/
function archive_edit_archive ($parent,$id) 
{
    global $_CONF, $_TABLES, $LANG_ACCESS, $LANG_ADMIN, $_USER, $_GROUPS, $LANG_AR, $_AR_CONF;

    $retval = '';

    // Set templates
    $T = new Template($_CONF['path'] . 'plugins/archive/templates/');
    $T->set_file('page','archive_editor.thtml');
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);
    $T->set_var('layout_url',$_CONF['layout_url']);
    $T->set_var('plugin_name', $LANG_AR['archive']);
    $T->set_var('lang_explanation', $LANG_AR['archive_editor']);
    $T->set_var('lang_title', $LANG_AR['title']);
    $T->set_var('lang_id', $LANG_AR['id']);
    $T->set_var('lang_description', $LANG_AR['description']);

    // ID exists so must be editing an existing item
    if (!empty($id)) {
        $result = DB_query("SELECT * FROM {$_TABLES['archive']} WHERE id ='$id'");
        $A = DB_fetchArray($result);
        $access = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);

    // Check they are allowed to edit this item if it already exists
        if ($access == 0 OR $access == 2) {
            $retval .= COM_startBlock($LANG_LINKS_ADMIN[16], '',
                               COM_getBlockTemplate ('_msg_block', 'header'));
            $retval .= $LANG_LINKS_ADMIN[17];
            $retval .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally edit archive $id.");
            return $retval;
        }

    // No ID, so this is a new item. Set default values
    } else {
        $A['id'] = COM_makesid();
        $A['title'] = '';
        $A['description'] = '';
        $A['hits'] = 0;
        $A['owner_id'] = $_USER['uid'];
        if (isset ($_GROUPS['archive Admin'])) {
            $A['group_id'] = $_GROUPS['archive Admin'];
        } else {
            $A['group_id'] = SEC_getFeatureGroup ('archive.edit');
        }
        SEC_setDefaultPermissions ($A, $_AR_CONF['default_permissions']);
    }

// Set values to form
    $T->set_var('title', stripslashes ($A['title']));
    $T->set_var('id', $A['id']);
    $T->set_var('description', stripslashes ($A['description']));
    $T->set_var('hits', $A['hits']);
    $T->set_var('parent', $parent);

// Set permissions editor to form
    $T->set_var('lang_accessrights', $LANG_ACCESS['accessrights']);
    $T->set_var('lang_owner', $LANG_ACCESS['owner']);
    $ownername = COM_getDisplayName ($A['owner_id']);
    $T->set_var('owner_username', DB_getItem($_TABLES['users'],
                             'username', "uid = {$A['owner_id']}")); 
    $T->set_var('owner_name', $ownername);
    $T->set_var('owner', $ownername);
    $T->set_var('link_ownerid', $A['owner_id']);
    $T->set_var('lang_group', $LANG_ACCESS['group']);
    $T->set_var('group_dropdown',
                             SEC_getGroupDropdown ($A['group_id'], $access));
    $T->set_var('lang_permissions', $LANG_ACCESS['permissions']);
    $T->set_var('lang_permissionskey', $LANG_ACCESS['permissionskey']);
    $T->set_var('permissions_editor', SEC_getPermissionsHTML($A['perm_owner'],
                $A['perm_group'],$A['perm_members'],$A['perm_anon']));
    $T->set_var('lang_lockmsg', $LANG_ACCESS['permmsg']);

    $T->set_var('lang_save', $LANG_ADMIN['save']);
    $T->set_var('lang_cancel', $LANG_ADMIN['cancel']);

// Parse output
    $T->parse('output', 'page');
    $retval .= $T->finish($T->get_var('output'));

// Return
    return $retval;

}



/**
* Saves an item to the archive plugin database
*/

function archive_save_archive ($R)
{
    global $_CONF, $_GROUPS, $_TABLES, $_USER, $MESSAGE, $LANG_AR;
    $retval = '';

//echo "<pre>";
//print_r($R);
//echo "</pre>";
//exit;

    $id = COM_applyFilter($R['id']);
    $old_id = COM_applyFilter($R['old_id']);

    // Check ID exists (should, but the user may have deleted it)
    if (empty ($id)) {
        // Check if there is an old ID hidden in the form
        if (empty ($old_id)) {
            // No, so create a new one
            $id = COM_makeSid ();
        } else {
            // Yes, so use the old ID
            $id = $old_id;
        }
    }

    $owner_id     = COM_applyFilter($R['owner_id']);
    $group_id     = COM_applyFilter($R['group_id']);
    $perm_owner   = COM_applyFilter($R['perm_owner'][0]+$R['perm_owner'][1]);
    $perm_group   = COM_applyFilter($R['perm_group'][0]+$R['perm_group'][1]);
    $perm_members = COM_applyFilter($R['perm_members'][0]);
    $perm_anon    = COM_applyFilter($R['perm_anon'][0]);


    $title = addslashes (COM_checkHTML (COM_checkWords ($R['title'])));
    $description = addslashes (COM_checkHTML (COM_checkWords ($R['description'])));
    $parent = COM_applyFilter($R['parent']);

    // Set permissions value for user
    $access = 0;
    // Is there an existing item with the old ID?
    if (DB_count ($_TABLES['archive'], 'id', $old_id) > 0) {
        // Yes, so use saved access rights and set a flag
        $update = true;
        $result = DB_query ("SELECT created,owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['archive']} WHERE id = '{$old_id}'");
        $A = DB_fetchArray ($result);
        $access = SEC_hasAccess ($A['owner_id'], $A['group_id'],
                $A['perm_owner'], $A['perm_group'], $A['perm_members'],
                $A['perm_anon']);
        $created = "'".$A['created']."'";
    } else {
        // No, so use provided access rights
        $access = SEC_hasAccess ($owner_id, $group_id, $perm_owner, $perm_group,
                $perm_members, $perm_anon);
    }

    // Does the user have permission to edit this item?
    if (($access < 3) || !SEC_inGroup ($group_id)) {
        // No, so tell them so and log it
        $display .= COM_siteHeader ('menu', $MESSAGE[30]);
        $display .= COM_startBlock ($MESSAGE[30], '',
                            COM_getBlockTemplate ('_msg_block', 'header'));
        $display .= $MESSAGE[31];
        $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        $display .= COM_siteFooter ();
        COM_accessLog("User {$_USER['username']} tried to illegally submit or edit archive $id.");
        echo $display;
        exit;
    } elseif (!empty($title) && !empty($description)) {
        // Yes, so proceed
        // Check if the ID has changed
        if (!empty($id) && !empty($old_id) && $id<>$old_id) {
            // ID changed so delete existing item
            DB_delete ($_TABLES['archive'], 'id', $old_id);
        }
        if (!$update) {
            $created = "NOW()";
        }
        // Save this item
        DB_save ($_TABLES['archive'], 'id,parent,title,description,created,modified,hits,
        owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon', 
        "'$id','$parent','$title','$description',$created,NOW(),'$hits',
        '$owner_id','$group_id','$perm_owner','$perm_group','$perm_members','$perm_anon'");

        // Update RDF
        COM_rdfUpToDateCheck ('archive', $title, $id);
        // Set return message
        $retval = $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=1';
    } else {
        // Missing data
        $retval = $_CONF['site_url']. '/archive/index.php?msg=4';
    }
    
    // Return result
    return $retval;
}



/**
* Sets modified date on archive item if child is modified
*/

function archive_modified_date($id) {
    global $_TABLES;
    
    DB_Query ("UPDATE {$_TABLES['archive']} SET modified=NOW() WHERE id='{$id}'");
    
    return;
}
        





/**
* Delete an archive
*/

function archive_delete_archive ($archive)
{
    global $_CONF, $_TABLES, $_USER;

    $result = DB_query ("SELECT parent,owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['archive']} WHERE id ='$archive'");
    $A = DB_fetchArray ($result);
    $parent = $A['parent'];
    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'], $A['perm_owner'],
            $A['perm_group'], $A['perm_members'], $A['perm_anon']);
    if ($access < 3) {
        COM_accessLog ("User {$_USER['username']} tried to illegally delete archive $archive.");
        return $_CONF['site_url'] . '/archive/index.php?id='.$archive;
    }

    $result = DB_query ("SELECT id FROM {$_TABLES['archive']} WHERE parent ='$archive'");
    if (DB_numRows($result) > 0) {
        return $_CONF['site_url'] . '/archive/index.php?id='.$archive.'&msg=6';
    }

    // Delete archive item and children
    DB_delete ($_TABLES['archive'], 'id', $archive);
    DB_delete($_TABLES['archive_text'], 'parent', $archive);
    DB_delete($_TABLES['archive_url'], 'parent', $archive);
    DB_delete($_TABLES['archive_address'], 'parent', $archive);

    return $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=2';
}




// +---------------------------------------------------------------------------+
// | Archive text item functions                                               |
// +---------------------------------------------------------------------------+

// archive_list_texts
// archive_edit_text
// archive_save_text
// archive_delete_text



function archive_list_texts ($parent) {
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';

// Get all archives from DB

    $result = DB_query ("SELECT * FROM ".$_TABLES['archive_text']." WHERE (parent='".$parent."')");

// Set template variables
    $T = new Template($_CONF['path'] . 'plugins/archive/templates/');
    $T->set_file(array ('list' => 'text_list.thtml',
                        'item' => 'text_item.thtml'));
    $T->set_var('site_url', $_CONF['site_url']);


// Loop through texts
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $T->set_var('lang_archive_texts', $LANG_AR['archive_texts']);
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
            $T->set_var ('text_title', $A['title']);
            $linefeed = "\r";
            $content =  str_replace($linefeed, "<BR />", $A['content']);
            $T->set_var ('text_content', PLG_replaceTags($content));
            // add link to edit if has rights
            if (SEC_hasRights('archive.edit')) {
                $editurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit&type=text&id='.$A['textid']);
                $link = '<a href="'.$editurl.'" title="' . $LANG_AR['edit'] . '">' 
                        . '<img src="'.$_CONF['site_url'] . '/archive/images/edit.gif">' 
                        . '</a>';
                $deleteurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=delete&type=text&id='.$A['textid']);
                $link .= '<a href="'.$deleteurl.'" title="' . $LANG_AR['delete'] . '">' 
                        . '<img src="'.$_CONF['site_url'] . '/archive/images/delete.gif">' 
                        . '</a>';
                $T->set_var('edit_text_item', $link);
            } else {
                $T->set_var('edit_text_item', '');
            }
            $T->parse ('archive_texts', 'item', true);
        }
   } else {
       // Set link to create new text if has rights
        if (SEC_hasRights('archive.edit')) {
            $T->set_var('lang_archive_texts', $LANG_AR['archive_texts']);
            $T->set_var('archive_texts', $LANG_AR['no_texts']);
        } else {
            $T->set_var('lang_archive_texts', '');
            $T->set_var('add_text', '');
            $T->set_var('archive_texts', '');
        }
    }

    if (SEC_hasRights('archive.edit')) {
        $url = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit&type=text&parent='.$parent);
        $link = '<a href="'.$url.'" title="' . $LANG_AR['add_text'] . '">' 
                    . '<img src="'.$_CONF['site_url'] . '/archive/images/add.gif">' 
                    . '</a>';
        $T->set_var('add_text', $link);
    }

// Parse template
    $T->parse('output', 'list');
    $retval = $T->finish($T->get_var('output'));

// Return HTML

    return $retval;
}




function archive_edit_text ($parent, $textid = '') 
{
    global $_CONF, $LANG_AR, $LANG_ADMIN, $_AR_CONF, $_TABLES;

    $retval = '';

    // Check at least one ID exists
    if (empty($parent) && empty($textid)) {
        return COM_refresh ($_CONF['site_url']. '/archive/index.php?msg=4');
    }

    // Check ID exists
    if (empty ($textid)) {
        // No, so create a new one
        $textid = COM_makeSid ();
        $title = '';
        $content = '';
    } else {
        // Existing item, so get data
        $result = DB_query ("SELECT * FROM ".$_TABLES['archive_text']." WHERE (textid='".$textid."')");
        $A = DB_fetchArray ($result);
        $parent = $A['parent'];
        $textid = $A['textid'];
        $title = stripslashes($A['title']);
        $content = stripslashes($A['content']);
    }

    // Set templates
    $T = new Template($_CONF['path'] . 'plugins/archive/templates/');
    $T->set_file('page','text_editor.thtml');
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('layout_url',$_CONF['layout_url']);
    $T->set_var('plugin_name', $LANG_AR['archive']);
    $T->set_var('description', $LANG_AR['text_editor']);
    $T->set_var('title', $title);
    $T->set_var('content', $content);
    $T->set_var('parent', $parent);
    $T->set_var('textid', $textid);
    $T->set_var('lang_title', $LANG_AR['title']);
    $T->set_var('lang_content', $LANG_AR['content']);
    $T->set_var('lang_save', $LANG_ADMIN['save']);
    $T->set_var('lang_cancel', $LANG_ADMIN['cancel']);

    // Parse output
    $T->parse('output', 'page');
    $retval .= $T->finish($T->get_var('output'));

// Return
    return $retval;

}



/**
* Saves a text item to the archive plugin database
*/

function archive_save_text ($R)
{
    global $_CONF, $_GROUPS, $_TABLES, $_USER, $MESSAGE, $LANG_AR;
    $retval = '';

    $textid = COM_applyFilter ($R['textid']);
    $title = addslashes (COM_checkHTML (COM_checkWords ($R['title'])));
    $content = addslashes (COM_checkHTML (COM_checkWords ($R['content'])));
    $parent = COM_applyFilter ($R['parent']);

    // Does user have access permission on the parent item?
    $access = 0;
    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['archive']} WHERE id='{$parent}'");
    $A = DB_fetchArray ($result);
    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'], $A['perm_owner'], $A['perm_group'], $A['perm_members'],$A['perm_anon']);

    // Does the user have permission to edit this item?
    if (($access < 3) || !SEC_inGroup ($A['group_id'])) {
        // No, so tell them so and log it
        $display .= COM_siteHeader ('menu', $MESSAGE[30]);
        $display .= COM_startBlock ($MESSAGE[30], '',
                            COM_getBlockTemplate ('_msg_block', 'header'));
        $display .= $MESSAGE[31];
        $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        $display .= COM_siteFooter ();
        COM_accessLog("User {$_USER['username']} tried illegally to edit archive $id.");
        echo $display;
        exit;
    } elseif (!empty($title) && !empty($content)) {
        // Yes, so save this item
        DB_save ($_TABLES['archive_text'], 'textid,parent,title,content', 
        "'$textid','$parent','$title','$content'");

        // Updatemodified date on parent
        archive_modified_date($parent);
        
        // Update RDF
        COM_rdfUpToDateCheck ('archive', $title, $parent);
        // Set return message
        $retval = $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=1';
    } else {
        // Missing data
        $retval = $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=4';
    }
    
    // Return result
    return $retval;
}




/**
* Delete an archive text item
*/

function archive_delete_text ($textid)
{
    global $_CONF, $_TABLES, $_USER;

    // Get parent ID
    $result = DB_query ("SELECT parent FROM {$_TABLES['archive_text']} WHERE textid ='$textid'");
    $A = DB_fetchArray ($result);
    $parent = $A['parent'];

    // Get permission values
    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['archive']} WHERE id ='{$parent}'");
    $A = DB_fetchArray ($result);
    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'], $A['perm_owner'],
            $A['perm_group'], $A['perm_members'], $A['perm_anon']);
    if ($access < 3) {
        // No access rights, so log and return
        COM_accessLog ("User {$_USER['username']} tried to illegally delete archive text $textid.");
        return $_CONF['site_url'] . '/archive/index.php';
    }

    // Delete text item
    DB_delete ($_TABLES['archive_text'], 'textid', $textid);

    // return a refresh url
    return $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=3';
}







// +---------------------------------------------------------------------------+
// | Archive address item functions                                                |
// +---------------------------------------------------------------------------+

// archive_list_addresses
// archive_edit_address
// archive_save_address
// archive_delete_address



function archive_list_addresses ($parent) {
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';

// Get all archives from DB

    $result = DB_query ("SELECT * FROM ".$_TABLES['archive_address']." WHERE (parent='".$parent."')");

// Set template variables
    $T = new Template($_CONF['path'] . 'plugins/archive/templates/');
    $T->set_file(array ('list' => 'address_list.thtml',
                        'item' => 'address_item.thtml'));
    $T->set_var('site_url', $_CONF['site_url']);


// Loop through texts
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $T->set_var('lang_archive_addresses', $LANG_AR['archive_addresses']);
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
            $T->set_var ('address_title', $A['title']);

            if (!empty($A['address1'])) {
                $T->set_var('address1', stripslashes($A['address1']).'<br>');
                $T->set_var('lang_address1', $LANG_AR['address1'].': ');
           }
            if (!empty($A['address2'])) {
                $T->set_var('address2', stripslashes($A['address2']).'<br>');
                $T->set_var('lang_address2', $LANG_AR['address2'].': ');
            }
            if (!empty($A['address3'])) {
                $T->set_var('address3', stripslashes($A['address3']).'<br>');
                $T->set_var('lang_address3', $LANG_AR['address3'].': ');
            }
            if (!empty($A['address4'])) {
                $T->set_var('address4', stripslashes($A['address4']).'<br>');
                $T->set_var('lang_address4', $LANG_AR['address4'].': ');
            }
            if (!empty($A['address5'])) {
                $T->set_var('address5', stripslashes($A['address5']).'<br>');
                $T->set_var('lang_address5', $LANG_AR['address5'].': ');
            }
            if (!empty($A['city'])) {
                $T->set_var('city', stripslashes($A['city']).'<br>');
                $T->set_var('lang_city', $LANG_AR['city'].': ');
            }
            if (!empty($A['state'])) {
                $T->set_var('state', stripslashes($A['state']).'<br>');
                $T->set_var('lang_state', $LANG_AR['state'].': ');
            }
            if (!empty($A['country'])) {
                $T->set_var('country', stripslashes($A['country']).'<br>');
                $T->set_var('lang_country', $LANG_AR['country'].': ');
            }
            if (!empty($A['postcode'])) {
                $T->set_var('postcode', stripslashes($A['postcode']).'<br>');
                $T->set_var('lang_postcode', $LANG_AR['postcode'].': ');
            }
            if (!empty($A['telephone1'])) {
                $T->set_var('telephone1', stripslashes($A['telephone1']).'<br>');
                $T->set_var('lang_telephone1', $LANG_AR['telephone1'].': ');
            }
            if (!empty($A['telephone2'])) {
                $T->set_var('telephone2', stripslashes($A['telephone2']).'<br>');
                $T->set_var('lang_telephone2', $LANG_AR['telephone2'].': ');
            }
            if (!empty($A['telephone3'])) {
                $T->set_var('telephone3', stripslashes($A['telephone3']).'<br>');
                $T->set_var('lang_telephone3', $LANG_AR['telephone3'].': ');
            }
            if (!empty($A['facsimile1'])) {
                $T->set_var('facsimile1', stripslashes($A['facsimile1']).'<br>');
                $T->set_var('lang_facsimile1', $LANG_AR['facsimile1'].': ');
            }
            if (!empty($A['facsimile2'])) {
                $T->set_var('facsimile2', stripslashes($A['facsimile2']).'<br>');
                $T->set_var('lang_facsimile2', $LANG_AR['facsimile2'].': ');
            }
            if (!empty($A['facsimile3'])) {
                $T->set_var('facsimile3', stripslashes($A['facsimile3']).'<br>');
                $T->set_var('lang_facsimile3', $LANG_AR['facsimile3'].': ');
            }

            // add link to edit if has rights
            if (SEC_hasRights('archive.edit')) {
                $editurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit&type=address&id='.$A['addressid']);
                $link = '<a href="'.$editurl.'" title="' . $LANG_AR['edit'] . '">' 
                        . '<img src="'.$_CONF['site_url'] . '/archive/images/edit.gif">' 
                        . '</a>';
                $deleteurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=delete&type=address&id='.$A['addressid']);
                $link .= '<a href="'.$deleteurl.'" title="' . $LANG_AR['delete'] . '">' 
                        . '<img src="'.$_CONF['site_url'] . '/archive/images/delete.gif">' 
                        . '</a>';
                $T->set_var('edit_address_item', $link);
            } else {
                $T->set_var('edit_address_item', '');
            }
            $T->parse ('archive_addresses', 'item', true);
        }
   } else {
       // Set link to create new address if has rights
        if (SEC_hasRights('archive.edit')) {
            $T->set_var('lang_archive_addresses', $LANG_AR['archive_addresses']);
            $T->set_var('archive_addresses', $LANG_AR['no_addresses']);
        } else {
            $T->set_var('lang_archive_addresses', '');
            $T->set_var('add_address', '');
            $T->set_var('archive_addresses', '');
        }
    }

    if (SEC_hasRights('archive.edit')) {
        $url = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit&type=address&parent='.$parent);
        $link = '<a href="'.$url.'" title="' . $LANG_AR['add_address'] . '">' 
                    . '<img src="'.$_CONF['site_url'] . '/archive/images/add.gif">' 
                    . '</a>';
        $T->set_var('add_address', $link);
    }

// Parse template
    $T->parse('output', 'list');
    $retval = $T->finish($T->get_var('output'));

// Return HTML
    return $retval;
}




function archive_edit_address ($parent, $addressid = '') 
{
    global $_CONF, $LANG_AR, $LANG_ADMIN, $_AR_CONF, $_TABLES;

    $retval = '';

    // Check at least one ID exists
    if (empty($parent) && empty($addressid)) {
        return COM_refresh ($_CONF['site_url']. '/archive/index.php?msg=4');
    }

    // Check ID exists
    if (empty ($addressid)) {
        // No, so create a new one
        $addressid = COM_makeSid ();
        $title = '';
    } else {
        // Existing item, so get data
        $result = DB_query ("SELECT * FROM ".$_TABLES['archive_address']." WHERE (addressid ='".$addressid."')");
        $A = DB_fetchArray ($result);
        $parent = $A['parent'];
        $addressid = $A['addressid'];
        $title = stripslashes($A['title']);
    }

    // Set templates
    $T = new Template($_CONF['path'] . 'plugins/archive/templates/');
    $T->set_file('page','address_editor.thtml');
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('layout_url',$_CONF['layout_url']);
    $T->set_var('plugin_name', $LANG_AR['archive']);
    $T->set_var('description', $LANG_AR['address_editor']);
    $T->set_var('title', $title);
    $T->set_var('parent', $parent);
    $T->set_var('addressid', $addressid);
    $T->set_var('address1', stripslashes($A['address1']));
    $T->set_var('address2', stripslashes($A['address2']));
    $T->set_var('address3', stripslashes($A['address3']));
    $T->set_var('address4', stripslashes($A['address4']));
    $T->set_var('address5', stripslashes($A['address5']));
    $T->set_var('city', stripslashes($A['city']));
    $T->set_var('state', stripslashes($A['state']));
    $T->set_var('country', stripslashes($A['country']));
    $T->set_var('postcode', stripslashes($A['postcode']));
    $T->set_var('telephone1', stripslashes($A['telephone1']));
    $T->set_var('telephone2', stripslashes($A['telephone2']));
    $T->set_var('telephone3', stripslashes($A['telephone3']));
    $T->set_var('facsimile1', stripslashes($A['facsimile1']));
    $T->set_var('facsimile2', stripslashes($A['facsimile2']));
    $T->set_var('facsimile3', stripslashes($A['facsimile3']));
    $T->set_var('lang_title', $LANG_AR['title']);
    $T->set_var('lang_address1', $LANG_AR['address1']);
    $T->set_var('lang_address2', $LANG_AR['address2']);
    $T->set_var('lang_address3', $LANG_AR['address3']);
    $T->set_var('lang_address4', $LANG_AR['address4']);
    $T->set_var('lang_address5', $LANG_AR['address5']);
    $T->set_var('lang_city', $LANG_AR['city']);
    $T->set_var('lang_state', $LANG_AR['state']);
    $T->set_var('lang_country', $LANG_AR['country']);
    $T->set_var('lang_postcode', $LANG_AR['postcode']);
    $T->set_var('lang_telephone1', $LANG_AR['telephone1']);
    $T->set_var('lang_telephone2', $LANG_AR['telephone2']);
    $T->set_var('lang_telephone3', $LANG_AR['telephone3']);
    $T->set_var('lang_facsimile1', $LANG_AR['facsimile1']);
    $T->set_var('lang_facsimile2', $LANG_AR['facsimile2']);
    $T->set_var('lang_facsimile3', $LANG_AR['facsimile3']);
    $T->set_var('lang_save', $LANG_ADMIN['save']);
    $T->set_var('lang_cancel', $LANG_ADMIN['cancel']);

    // Parse output
    $T->parse('output', 'page');
    $retval .= $T->finish($T->get_var('output'));

// Return
    return $retval;

}



/**
* Saves an address item to the archive plugin database
*/

function archive_save_address ($R)
{
    global $_CONF, $_GROUPS, $_TABLES, $_USER, $MESSAGE, $LANG_AR;
    $retval = '';

//echo "<pre>";
//print_r($R);
//echo "</pre>";
//exit;


    $addressid = COM_applyFilter ($R['addressid']);
    $parent = COM_applyFilter ($R['parent']);
    $title = addslashes (COM_checkHTML (COM_checkWords ($R['title'])));
    $address1 = addslashes (COM_checkHTML (COM_checkWords ($R['address1'])));
    $address2 = addslashes (COM_checkHTML (COM_checkWords ($R['address2'])));
    $address3 = addslashes (COM_checkHTML (COM_checkWords ($R['address3'])));
    $address4 = addslashes (COM_checkHTML (COM_checkWords ($R['address4'])));
    $address5 = addslashes (COM_checkHTML (COM_checkWords ($R['address5'])));
    $city = addslashes (COM_checkHTML (COM_checkWords ($R['city'])));
    $state = addslashes (COM_checkHTML (COM_checkWords ($R['state'])));
    $country = addslashes (COM_checkHTML (COM_checkWords ($R['country'])));
    $postcode = addslashes (COM_checkHTML (COM_checkWords ($R['postcode'])));
    $telephone1 = addslashes (COM_checkHTML (COM_checkWords ($R['telephone1'])));
    $telephone2 = addslashes (COM_checkHTML (COM_checkWords ($R['telephone2'])));
    $telephone3 = addslashes (COM_checkHTML (COM_checkWords ($R['telephone3'])));
    $facsimile1 = addslashes (COM_checkHTML (COM_checkWords ($R['facsimile1'])));
    $facsimile2 = addslashes (COM_checkHTML (COM_checkWords ($R['facsimile2'])));
    $facsimile3 = addslashes (COM_checkHTML (COM_checkWords ($R['facsimile3'])));

    // Does user have access permission on the parent item?
    $access = 0;
    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['archive']} WHERE id='{$parent}'");
    $A = DB_fetchArray ($result);
    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'], $A['perm_owner'], $A['perm_group'], $A['perm_members'],$A['perm_anon']);

    // Does the user have permission to edit this item?
    if (($access < 3) || !SEC_inGroup ($A['group_id'])) {
        // No, so tell them so and log it
        $display .= COM_siteHeader ('menu', $MESSAGE[30]);
        $display .= COM_startBlock ($MESSAGE[30], '',
                            COM_getBlockTemplate ('_msg_block', 'header'));
        $display .= $MESSAGE[31];
        $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        $display .= COM_siteFooter ();
        COM_accessLog("User {$_USER['username']} tried illegally to edit archive address $id.");
        echo $display;
        exit;
    } elseif (!empty($title)) {
        // Yes, so save this item
        DB_save ($_TABLES['archive_address'], 'addressid,parent,title,
        address1,address2,address3,address4,address5,city,state,country,postcode,
        telephone1,telephone2,telephone3,facsimile1,facsimile2,facsimile3', 
        "'$addressid','$parent','$title',
        '$address1','$address2','$address3','$address4','$address5','$city','$state','$country','$postcode',
        '$telephone1','$telephone2','$telephone3','$facsimile1','$facsimile2','$facsimile3'");

        // Updatemodified date on parent
        archive_modified_date($parent);
        
        // Update RDF
        COM_rdfUpToDateCheck ('archive', $title, $parent);
        // Set return message
        $retval = $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=1';
    } else {
        // Missing data
        $retval = $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=4';
    }

    // Return result
    return $retval;
}




/**
* Delete an archive address item
*/

function archive_delete_address ($addressid)
{
    global $_CONF, $_TABLES, $_USER;

    // Get parent ID
    $result = DB_query ("SELECT parent FROM {$_TABLES['archive_address']} WHERE addressid ='$addressid'");
    $A = DB_fetchArray ($result);
    $parent = $A['parent'];

    // Get permission values
    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['archive']} WHERE id ='{$parent}'");
    $A = DB_fetchArray ($result);
    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'], $A['perm_owner'],
            $A['perm_group'], $A['perm_members'], $A['perm_anon']);
    if ($access < 3) {
        // No access rights, so log and return
        COM_accessLog ("User {$_USER['username']} tried to illegally delete archive address $urlid.");
        return $_CONF['site_url'] . '/archive/index.php';
    }

    // Delete text item
    DB_delete ($_TABLES['archive_address'], 'addressid', $addressid);

    // return a refresh url
    return $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=3';
}




// +---------------------------------------------------------------------------+
// | Archive related item functions                                            |
// +---------------------------------------------------------------------------+

// archive_list_related
// archive_edit_related
// archive_save_related
// archive_delete_related


/**
* List items that are related to this archive
* This function just loops through each plugin type
*/

function archive_list_related ($parent) {
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';

    // Get plugins from database
    $result = DB_query ("SELECT pi_name FROM ".$_TABLES['plugins']." WHERE pi_enabled=1");
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
            if (function_exists ('archive_make_'.$A['pi_name'].'_list') && function_exists ('archive_'.$A['pi_name'].'_item')) {
                $retval .= archive_parse_related($parent,$A['pi_name']);
            }
        }
    }
    $retval .= archive_parse_related($parent,'story');
    $retval .= archive_parse_related($parent,'mediagallery_thumb');

    // Return HTML
    return $retval;
}




function archive_parse_related ($parent, $plugin) {
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';

    // Get all items from DB
    $result = DB_query ("SELECT * FROM ".$_TABLES['archive_related']." WHERE (parent='".$parent."' AND plugin='".$plugin."')");

    // Set template variables
    $T = new Template($_CONF['path'] . 'plugins/archive/templates/');
    $T->set_file(array ('list' => 'related_list.thtml',
                        'item' => 'related_item.thtml'));
    $T->set_var('site_url', $_CONF['site_url']);
    // Get title to display
    $function = 'archive_'.$plugin.'_name';

    // Loop through items
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        // Set title
        $T->set_var('lang_archive_related', $function());
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
            $function2 = 'archive_'.$plugin.'_item';
            $item = $function2 ($A['relatedid']);
			$img = $item['img'];
			if (!empty($A['title'])) {
				$title = $A['title'];
				$description = $A['description'];
			} else {
				$title = $item['title'];
				$description = '';
			}
			if (isset($img)) {
				$T->set_var ('related_link_item', $img);
				$T->set_var ('related_comment', $title);
			} else {
				$T->set_var ('related_link_item', $title);
				$T->set_var ('related_comment', $description);
			}
            $T->set_var ('related_link', $item['link']);
            // add link to edit if has rights
            if (SEC_hasRights('archive.edit')) {
                $editurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit&type=related&id='.$A['relatedid']);
                $link = '<a href="'.$editurl.'" title="' . $LANG_AR['edit'] . '">' 
                        . '<img src="'.$_CONF['site_url'] . '/archive/images/edit.gif">' 
                        . '</a>';
                $deleteurl = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=delete&type=related&id='.$A['relatedid']);
                $link .= '<a href="'.$deleteurl.'" title="' . $LANG_AR['delete'] . '">' 
                        . '<img src="'.$_CONF['site_url'] . '/archive/images/delete.gif">' 
                        . '</a>';
                $T->set_var('edit_related_item', $link);
            } else {
                $T->set_var('edit_related_item', '');
            }
            $T->parse ('archive_related', 'item', true);
        }
   } else {
       // No items to show
        if (SEC_hasRights('archive.edit')) {
            // Set title and label for editors only
            $T->set_var('lang_archive_related', $function());
            $T->set_var('archive_related', $LANG_AR['no_related']);
        } else {
            $T->set_var('lang_archive_related', '');
            $T->set_var('add_related', '');
            $T->set_var('archive_related', '');
        }
    }

    if (SEC_hasRights('archive.edit')) {
        $url = COM_buildUrl ($_CONF['site_url'] . '/archive/index.php?mode=edit&type=related&plugin='.$plugin.'&parent='.$parent);
        $link = '<a href="'.$url.'" title="' . $LANG_AR['add_related'] . '">' 
                    . '<img src="'.$_CONF['site_url'] . '/archive/images/add.gif">' 
                    . '</a>';
        $T->set_var('add_related', $link);
    }

// Parse template
    $T->parse('output', 'list');
    $retval = $T->finish($T->get_var('output'));

    // Return HTML
    return $retval;
}




/**
* Edit archive related item
*/

function archive_edit_related ($parent, $plugin, $relatedid = '') 
{
    global $_CONF, $LANG_AR, $LANG_ADMIN, $_AR_CONF, $_TABLES;

    $retval = '';

    // Check at least one ID exists
    if (empty($parent) && empty($relatedid)) {
        return COM_refresh ($_CONF['site_url']. '/archive/index.php?msg=4');
    }

    // Check ID exists
    if (!empty ($relatedid)) {
        // Existing item, so get data
        $result = DB_query ("SELECT * FROM ".$_TABLES['archive_related']." WHERE (relatedid ='".$relatedid."')");
        $A = DB_fetchArray ($result);
        $parent = $A['parent'];
        $plugin = $A['plugin'];
        $title = $A['title'];
        $description = $A['description'];
    }

    // Set templates
    $T = new Template($_CONF['path'] . 'plugins/archive/templates/');
    $T->set_file('page','related_editor.thtml');
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('layout_url',$_CONF['layout_url']);
    $T->set_var('plugin_name', $LANG_AR['archive']);
    $T->set_var('lang_comment', $LANG_AR['related_editor']);
    $T->set_var('lang_title', $LANG_AR['title']);
    $T->set_var('lang_description', $LANG_AR['description']);
    $T->set_var('title', $title);
    $T->set_var('description', $description);
    $T->set_var('related', $related);
    $T->set_var('parent', $parent);
    $T->set_var('id', $relatedid);

    $T->set_var('lang_related', $LANG_AR['archive_related']);
    // Get the function from the plugin
    $function = 'archive_make_'.$plugin.'_list';
    $T->set_var('archive_option_list', $function($relatedid));
    $T->set_var('related_list_name', 'relatedid');
    $T->set_var('plugin_name', 'plugin');
    $T->set_var('plugin_value', $plugin);
    $T->set_var('oldid', $relatedid);

    $T->set_var('lang_save', $LANG_ADMIN['save']);
    $T->set_var('lang_cancel', $LANG_ADMIN['cancel']);

    // Parse output
    $T->parse('output', 'page');
    $retval .= $T->finish($T->get_var('output'));

// Return
    return $retval;

}



/**
* Saves a related item to the archive plugin database
*/

function archive_save_related ($R)
{
    global $_CONF, $_GROUPS, $_TABLES, $_USER, $MESSAGE, $LANG_AR;
    $retval = '';

/*
echo "<pre>";
print_r($R);
echo "</pre>";
exit;
*/

    $relatedid = COM_applyFilter ($R['relatedid']);
    $oldid = COM_applyFilter ($R['oldid']);
    $parent = COM_applyFilter ($R['parent']);
    $title = addslashes (COM_checkHTML (COM_checkWords ($R['title'])));
    $description = addslashes (COM_checkHTML (COM_checkWords ($R['description'])));
    $plugin = addslashes (COM_checkHTML (COM_checkWords ($R['plugin'])));

/*
echo "<pre>";
echo "relatedid: " . $relatedid;
echo "<br>parent: " . $parent;
echo "<br>plugin: " . $plugin;
echo "<br>title: " . $title;
echo "<br>description: " . $description;
echo "</pre>";
exit;
*/

    // Does user have access permission on the parent item?
    $access = 0;
    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['archive']} WHERE id='{$parent}'");
    $A = DB_fetchArray ($result);
    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'], $A['perm_owner'], $A['perm_group'], $A['perm_members'],$A['perm_anon']);

/*
echo $access;
exit;
*/

    // Does the user have permission to edit this item?
    if (($access < 3) || !SEC_inGroup ($A['group_id'])) {
        // No, so tell them so and log it
        $display .= COM_siteHeader ('menu', $MESSAGE[30]);
        $display .= COM_startBlock ($MESSAGE[30], '',
                            COM_getBlockTemplate ('_msg_block', 'header'));
        $display .= $MESSAGE[31];
        $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        $display .= COM_siteFooter ();
        COM_accessLog("User {$_USER['username']} tried illegally to edit archive $id.");
        echo $display;
        exit;
    } elseif (!empty($relatedid) && !empty($plugin)) {
        // Yes, so save this item
        DB_save ($_TABLES['archive_related'], 'relatedid,parent,plugin,title,description', 
        "'$relatedid','$parent','$plugin','$title','$description'");

        // Check if id was changed
        if (($relatedid<>$oldid) && ($oldid<>'')) {
            DB_Delete ($_TABLES['archive_related'],'relatedid',$oldid);
        }

        // Updatemodified date on parent
        archive_modified_date($parent);
        
        // Update RDF
        COM_rdfUpToDateCheck ('archive', $title, $parent);
        // Set return message
        $retval = $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=1';
    } else {
        // Missing data
        $retval = $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=4';
    }

    // Return result
    return $retval;
}




/**
* Delete an archive related item
*/

function archive_delete_related ($relatedid)
{
    global $_CONF, $_TABLES, $_USER;

    // Get parent ID
    $result = DB_query ("SELECT parent FROM {$_TABLES['archive_related']} WHERE relatedid ='$relatedid'");
    $A = DB_fetchArray ($result);
    $parent = $A['parent'];

    // Get permission values
    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['archive']} WHERE id ='{$parent}'");
    $A = DB_fetchArray ($result);
    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'], $A['perm_owner'],
            $A['perm_group'], $A['perm_members'], $A['perm_anon']);
    if ($access < 3) {
        // No access rights, so log and return
        COM_accessLog ("User {$_USER['username']} tried to illegally delete archive related $relatedid.");
        return $_CONF['site_url'] . '/archive/index.php';
    }

    // Delete text item
    DB_delete ($_TABLES['archive_related'], 'relatedid', $relatedid);

    // return a refresh url
    return $_CONF['site_url']. '/archive/index.php?id='.$parent.'&msg=2';
}





/** ********************  Functions for related items  ******************** **/




// +---------------------------------------------------------------------------+
// | Staticpages                                                               |
// +---------------------------------------------------------------------------+

/**
* Returns the plugin name
*/

function archive_staticpages_name()
{
    global $LANG_AR_LABELS;
    return $LANG_AR_LABELS['staticpages'];
}


/**
* Returns a list of all staticpages
*/

function archive_make_staticpages_list($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
   // Get staticpage title from DB
    $perms = COM_getPermSql();
    $result = DB_query ("SELECT sp_id,sp_title FROM ".$_TABLES['staticpage'] . " " .$perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $retval = '<select name="relatedid">';
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
			if ($id==$A['sp_id']) {
				$selected = ' SELECTED';
			} else {
				$selected ='';
			}
            $retval .= '<option'.$selected.'  value="'.$A['sp_id'].'">'.$A['sp_title'].'</option>';
        }
        $retval .= "</select>";
    } else {
        $retval = $LANG_AR['noitemstoadd'];
    }
   return $retval;
}



/**
* Returns array of title and link to a staticpage given id
*/

function archive_staticpages_item ($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';
    // Get staticpage title from DB
    $perms = COM_getPermSql('AND');
    $result = DB_query ("SELECT sp_title FROM {$_TABLES['staticpage']} WHERE (sp_id='{$id}') ". $perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $A = DB_fetchArray ($result);
        $retval['title'] = $A['sp_title'];
        $link = $_CONF['site_url'] . "/staticpages/index.php?page=".$id;
        $retval['link'] = $link;
    } else {
        $retval['title'] = $LANG_AR['itemdeleted'];
        $retval['link'] = "";
    }
   return $retval;
}




// +---------------------------------------------------------------------------+
// | Calendar                                                                  |
// +---------------------------------------------------------------------------+

/**
* Returns the plugin name
*/

function archive_calendar_name()
{
    global $LANG_AR_LABELS;
    return $LANG_AR_LABELS['calendar'];
}


/**
* Returns a list of all calendar events
*/

function archive_make_calendar_list($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
   // Get event title from DB
    $perms = COM_getPermSql();
    $result = DB_query ("SELECT eid,title FROM ".$_TABLES['events'] . " " .$perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $retval = '<select name="relatedid">';
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
			if ($id==$A['eid']) {
				$selected = ' SELECTED';
			} else {
				$selected ='';
			}
            $retval .= '<option'.$selected.' value="'.$A['eid'].'">'.$A['title'].'</option>';
        }
        $retval .= "</select>";
    } else {
        $retval = $LANG_AR['noitemstoadd'];
    }
   return $retval;
}



/**
* Returns array of title and link to an event given id
*/

function archive_calendar_item ($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';
    // Get event title from DB
    $perms = COM_getPermSql('AND');
    $result = DB_query ("SELECT title FROM {$_TABLES['events']} WHERE (eid='{$id}') ". $perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $A = DB_fetchArray ($result);
        $retval['title'] = $A['title'];
        $link = $_CONF['site_url'] . "/calendar/event.php?eid=".$id;
        $retval['link'] = $link;
    } else {
        $retval['title'] = $LANG_AR['itemdeleted'];
        $retval['link'] = "";
    }
   return $retval;
}


// +---------------------------------------------------------------------------+
// | MediaGallery Albums                                                       |
// +---------------------------------------------------------------------------+

/**
* Returns the plugin name
*/

function archive_mediagallery_name()
{
    global $LANG_AR_LABELS;
    return $LANG_AR_LABELS['albums'];
}



/**
* Returns a list of all MediaGallery albums
*/

function archive_make_mediagallery_list($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
   // Get album title from DB
    $perms = COM_getPermSql();
    $result = DB_query ("SELECT album_id,album_title FROM ".$_TABLES['mg_albums'] . " " .$perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $retval = '<select name="relatedid">';
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
			if ($id==$A['albumid']) {
				$selected = ' SELECTED';
			} else {
				$selected ='';
			}
            $retval .= '<option'.$selected.' value="'.$A['album_id'].'">'.$A['album_title'].'</option>';
        }
        $retval .= "</select>";
    } else {
        $retval = $LANG_AR['noitemstoadd'];
    }
   return $retval;
}



/**
* Returns array of title and link to a MediaGallery given id
*/

function archive_mediagallery_item ($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';
    // Get album title from DB
    $perms = COM_getPermSql('AND');
    $result = DB_query ("SELECT album_title FROM {$_TABLES['mg_albums']} WHERE (album_id='{$id}') ". $perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $A = DB_fetchArray ($result);
        $retval['title'] = $A['album_title'];
        $link = $_CONF['site_url'] . "/mediagallery/album.php?aid=".$id;
        $retval['link'] = $link;
    } else {
        $retval['title'] = $LANG_AR['itemdeleted'];
        $retval['link'] = "";
    }
   return $retval;
}



// +---------------------------------------------------------------------------+
// | MediaGallery Images                                                       |
// +---------------------------------------------------------------------------+

/**
* Returns the plugin name
*/

function archive_mediagallery_thumb_name()
{
    global $LANG_AR_LABELS;
    return $LANG_AR_LABELS['images'];
}



/**
* Returns a list of all MediaGallery images
*/

function archive_make_mediagallery_thumb_list($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
   // Get album title from DB
    $perms = COM_getPermSql('AND');
    $result = DB_query ("SELECT t1.media_id AS id,t1.media_title AS title,t3.album_title AS album FROM {$_TABLES['mg_media']} AS t1,  {$_TABLES['mg_media_albums']} AS t2, {$_TABLES['mg_albums']} AS t3 WHERE (t1.media_id=t2.media_id) AND (t2.album_id=t3.album_id)".$perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $retval = '<select name="relatedid">';
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
			if ($id==$A['id']) {
				$selected = ' SELECTED';
			} else {
				$selected ='';
			}
            $retval .= '<option'.$selected.' value="'.$A['id'].'">'.$A['album'].' - '.$A['title'].'</option>';
        }
        $retval .= "</select>";
    } else {
        $retval = $LANG_AR['noitemstoadd'];
    }
   return $retval;
}



/**
* Returns array of title and link to a MediaGallery image given id
*/

function archive_mediagallery_thumb_item ($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';
    // Get album title from DB
    $perms = COM_getPermSql('AND');
    $result = DB_query ("SELECT t1.media_title FROM {$_TABLES['mg_media']} AS t1,  {$_TABLES['mg_media_albums']} AS t2, {$_TABLES['mg_albums']} AS t3 WHERE (t1.media_id=t2.media_id) AND (t2.album_id=t3.album_id) AND (t1.media_id='{$id}') ". $perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $A = DB_fetchArray ($result);
        $img = archive_mediagallery_thumbnail($id);
        $retval['img'] = $img['img'];
        $retval['title'] = $img['title'];
        $link = $_CONF['site_url'] . "/mediagallery/media.php?s=".$id;
        $retval['link'] = $link;
    } else {
        $retval['title'] = $LANG_AR['itemdeleted'];
        $retval['link'] = "";
    }
   return $retval;
}

/*
$T->set_var ('image',$img['img']);
$T->set_var ('link',$img['link']);
$T->set_var ('title',$img['title']);
*/



/**
* Returns a thumbnail given an id
* By Mark Evans (MediaGallery)
*/
function archive_mediagallery_thumbnail( $id )
{
    global $_TABLES, $_MG_CONF;

    // check to see if Media Gallery is installed and active...
    if (!function_exists(MG_usage)) {
        return '';
    }

    $retval = array();

    $sql = "SELECT * FROM {$_TABLES['mg_media']} WHERE media_id=" . $id;
    $result = DB_query( $sql );
    $nRows  = DB_numRows( $result );
    if ( $nRows > 0 ) {
        $M = DB_fetchArray($result);

        switch( $M['media_type'] ) {
            case 0 :    // standard image
                $default_thumbnail = 'tn/' . $M['media_filename'][0] . '/' . $M['media_filename']. '.jpg';
                break;
            case 1 :    // video file
                switch ( $M['media_mime_ext'] ) {
                    case 'swf' :
                        $default_thumbnail = 'flash.gif';
                        break;
                    case 'mov' :
                    case 'mp4' :
                        $default_thumbnail = 'quicktime.gif';
                        break;
                    case 'asf' :
                        $default_thumbnail = 'wmp.gif';
                        break;
                    default :
                        $default_thumbnail = 'video.gif';
                        break;
                }
                break;
            case 2 :    // music file
                $default_thumbnail = 'audio.gif';
                break;
            case 4 :    // other files
                switch ($M['media_mime_ext']) {
                    case 'zip' :
                    case 'arj' :
                    case 'rar' :
                    case 'gz'  :
                        $default_thumbnail = 'zip.gif';
                        break;
                    case 'pdf' :
                        $default_thumbnail = 'pdf.gif';
                        break;
                    default :
                        $default_thumbnail = 'generic.gif';
                        break;
                }
                break;
        }

        if ( $M['media_tn_attached'] == 1 ) {
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/tn/'.  $M['media_filename'][0] . '/tn_' . $M['media_filename'] . '.jpg';
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/tn/'.  $M['media_filename'][0] . '/tn_' . $M['media_filename'] . '.jpg';
        } else {
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/' . $default_thumbnail;
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/' . $default_thumbnail;
        }

        $media_size        = @getimagesize($media_thumbnail_file);

        if ( $media_size == false ) {
            $default_thumbnail    = 'generic.gif';
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/' . $default_thumbnail;
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/' . $default_thumbnail;
            $media_size           = @getimagesize($media_thumbnail_file);
        }
        $tn_height = 250;
        if ( $media_size[0] > $media_size[1] ) {
            $ratio = $media_size[0] / $tn_height;
            $newwidth = $tn_height;
            $newheight = round($media_size[1] / $ratio);
        } else {
            $ratio = $media_size[1] / $tn_height;
            $newheight = $tn_height;
            $newwidth = round($media_size[0] / $ratio);
        }
        $media_dim = 'width="' . $newwidth . '" height="' . $newheight . '"';

        $img = '<img src="' .$media_thumbnail . '" ' . $media_dim . ' border="0" alt="' . strip_tags(COM_stripslashes($M['media_title'])) . '" title="' . strip_tags(COM_stripslashes($M['media_title'])) . '"/>';
        $link = $_MG_CONF['site_url'] . '/media.php?f=0' . '&amp;s=' . $M['media_id'] ;
        $title = strip_tags(COM_stripslashes($M['media_title']));
        $id    = $M['media_id'];
        $retval['id'] = $id;
        $retval['title'] = $title;
        $retval['img'] = $img;
        $retval['link'] = $link;
    } else {
        $retval['id'] = $id;
        $retval['title'] = '';
        $retval['img'] = '';
        $retval['link'] = '';
    }

    return $retval;
}






// +---------------------------------------------------------------------------+
// | Links                                                                     |
// +---------------------------------------------------------------------------+

/**
* Returns the plugin name
*/

function archive_links_name()
{
    global $LANG_AR_LABELS;
    return $LANG_AR_LABELS['links'];
}



/**
* Returns a list of all Links
*/

function archive_make_links_list($id)
{
    global $_TABLES, $LANG_AR;
   // Get link title from DB
    $perms = COM_getPermSql();
    $result = DB_query ("SELECT lid,title FROM ".$_TABLES['links'] . " " .$perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $retval = '<select name="relatedid">';
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
			if ($id==$A['lid']) {
				$selected = ' SELECTED';
			} else {
				$selected ='';
			}
            $retval .= '<option'.$selected.' value="'.$A['lid'].'">'.$A['title'].'</option>';
        }
        $retval .= "</select>";
    } else {
        $retval = $LANG_AR['noitemstoadd'];
    }
   return $retval;
}



/**
* Returns array of title and link to a Link given id
*/

function archive_links_item ($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';
    // Get link title from DB
    $perms = COM_getPermSql('AND');
    $result = DB_query ("SELECT title FROM {$_TABLES['links']} WHERE (lid='{$id}') ". $perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $A = DB_fetchArray ($result);
        $retval['title'] = $A['title'];
        $link = $_CONF['site_url'] . "/links/portal.php?what=link&item=".$id;
        $retval['link'] = $link;
    } else {
        $retval['title'] = $LANG_AR['itemdeleted'];
        $retval['link'] = "";
    }
   return $retval;
}


// +---------------------------------------------------------------------------+
// | Forum                                                                     |
// +---------------------------------------------------------------------------+

/**
* Returns the plugin name
*/

function archive_forum_name()
{
    global $LANG_AR_LABELS;
    return $LANG_AR_LABELS['forum'];
}



/**
* Returns a list of all forums
*/

function archive_make_forum_list($id)
{
    global $_TABLES, $LANG_AR;
   // Get forum title from DB
    $result = DB_query ("SELECT forum_id,forum_name FROM ".$_TABLES['gf_forums']);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $retval = '<select name="relatedid">';
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
			if ($id==$A['forum_id']) {
				$selected = ' SELECTED';
			} else {
				$selected ='';
			}
            $retval .= '<option'.$selected.' value="'.$A['forum_id'].'">'.$A['forum_name'].'</option>';
        }
        $retval .= "</select>";
    } else {
        $retval = $LANG_AR['noitemstoadd'];
    }
   return $retval;
}



/**
* Returns array of title and link to a forum given id
*/

function archive_forum_item ($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';
    // Get forum title from DB
    $result = DB_query ("SELECT forum_name FROM {$_TABLES['gf_forums']} WHERE (forum_id ='{$id}')");
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $A = DB_fetchArray ($result);
        $retval['title'] = $A['forum_name'];
        $link = $_CONF['site_url'] . "/forum/index.php?forum=".$id;
        $retval['link'] = $link;
    } else {
        $retval['title'] = $LANG_AR['itemdeleted'];
        $retval['link'] = "";
    }
   return $retval;
}


// +---------------------------------------------------------------------------+
// | File Management                                                           |
// +---------------------------------------------------------------------------+

/**
* Returns the plugin name
*/

function archive_filemgmt_name()
{
    global $LANG_AR_LABELS;
    return $LANG_AR_LABELS['filemgmt'];
}



/**
* Returns a list of all files
*/

function archive_make_filemgmt_list($id)
{
    global $_FM_TABLES, $LANG_AR;
    // Get file title from DB
    $perms = COM_getPermSql();
    $result = DB_query ("SELECT lid,title FROM " . $_FM_TABLES['filemgmt_filedetail'] . " " .$perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $retval = '<select name="relatedid">';
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
			if ($id==$A['lid']) {
				$selected = ' SELECTED';
			} else {
				$selected ='';
			}
            $retval .= '<option'.$selected.' value="'.$A['lid'].'">'.$A['title'].'</option>';
        }
        $retval .= "</select>";
    } else {
        $retval = $LANG_AR['noitemstoadd'];
    }
    return $retval;
}



/**
* Returns array of title and link to a file given id
*/

function archive_filemgmt_item ($id)
{
    global $_CONF, $_FM_TABLES, $LANG_AR;
    $retval = '';
    // Get file title from DB
    $perms = COM_getPermSql('AND');
    $result = DB_query ("SELECT title FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE (lid='{$id}') ". $perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $A = DB_fetchArray ($result);
        $retval['title'] = $A['title'];
        $link = $_CONF['site_url'] . "/filemgmt/singlefile.php?lid=".$id;
        $retval['link'] = $link;
    } else {
        $retval['title'] = $LANG_AR['itemdeleted'];
        $retval['link'] = "";
    }
   return $retval;
}


// +---------------------------------------------------------------------------+
// | Stories                                                                   |
// +---------------------------------------------------------------------------+

/**
* Returns the plugin name
*/

function archive_story_name()
{
    global $LANG_AR_LABELS;
    return $LANG_AR_LABELS['stories'];
}



/**
* Returns a list of all stories
*/

function archive_make_story_list($id)
{
    global $_TABLES, $LANG_AR;
    // Get file title from DB
    $perms = COM_getPermSql();
    $result = DB_query ("SELECT sid,title FROM " . $_TABLES['stories'] . " " .$perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $retval = '<select name="relatedid">';
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
			if ($id==$A['sid']) {
				$selected = ' SELECTED';
			} else {
				$selected ='';
			}
            $retval .= '<option'.$selected.' value="'.$A['sid'].'">'.$A['title'].'</option>';
        }
        $retval .= "</select>";
    } else {
        $retval = $LANG_AR['noitemstoadd'];
    }
    return $retval;
}



/**
* Returns array of title and link to a story given id
*/

function archive_story_item ($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';
    // Get file title from DB
    $perms = COM_getPermSql('AND');
    $result = DB_query ("SELECT title FROM {$_TABLES['stories']} WHERE (sid='{$id}') ". $perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $A = DB_fetchArray ($result);
        $retval['title'] = $A['title'];
        $link = $_CONF['site_url'] . "/article.php?story=".$id;
        $retval['link'] = $link;
    } else {
        $retval['title'] = $LANG_AR['itemdeleted'];
        $retval['link'] = "";
    }
   return $retval;
}


// +---------------------------------------------------------------------------+
// | Archive                                                                   |
// +---------------------------------------------------------------------------+

/**
* Returns the plugin name
*/

function archive_archive_name()
{
    global $LANG_AR_LABELS;
    return $LANG_AR_LABELS['archive'];
}


/**
* Returns a list of all archive items
*/

function archive_make_archive_list($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
   // Get event title from DB
    $perms = COM_getPermSql();
    $result = DB_query ("SELECT id,title FROM ".$_TABLES['archive'] . " " .$perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $retval = '<select name="relatedid">';
        for ($i = 1; $i <= $nrows; $i++) {
            $A = DB_fetchArray ($result);
			if ($id==$A['id']) {
				$selected = ' SELECTED';
			} else {
				$selected ='';
			}
            $retval .= '<option'.$selected.' value="'.$A['id'].'">'.$A['title'].'</option>';
        }
        $retval .= "</select>";
    } else {
        $retval = $LANG_AR['noitemstoadd'];
    }
   return $retval;
}



/**
* Returns array of title and link to an archive given id
*/

function archive_archive_item ($id)
{
    global $_CONF, $_TABLES, $LANG_AR;
    $retval = '';
    // Get event title from DB
    $perms = COM_getPermSql('AND');
    $result = DB_query ("SELECT title FROM {$_TABLES['archive']} WHERE (id='{$id}') ". $perms);
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $A = DB_fetchArray ($result);
        $retval['title'] = $A['title'];
        $link = $_CONF['site_url'] . "/archive/index.php?id=".$id;
        $retval['link'] = $link;
    } else {
        $retval['title'] = $LANG_AR['itemdeleted'];
        $retval['link'] = "";
    }
   return $retval;
}

/*
echo "<pre>";
print_r($_REQUEST);
echo "</pre>";
exit;
*/

// +---------------------------------------------------------------------------+
// | Main                                                                      |
// +---------------------------------------------------------------------------+

$mode = '';
if (isset ($_REQUEST['mode'])) {
    $mode = COM_applyFilter ($_REQUEST['mode']);
}
$type = '';
if (isset ($_REQUEST['type'])) {
    $type = COM_applyFilter ($_REQUEST['type']);
}
$plugin = '';
if (isset ($_REQUEST['plugin'])) {
    $plugin = COM_applyFilter ($_REQUEST['plugin']);
}
$id = '';
if (isset ($_REQUEST['id'])) {
    $id = COM_applyFilter ($_REQUEST['id']);
}
$parent = '0';
if (isset ($_REQUEST['parent'])) {
    $parent = COM_applyFilter ($_REQUEST['parent']);
}
$msg = '';
if (isset ($_REQUEST['msg'])) {
    $msg = COM_applyFilter ($_REQUEST['msg']);
}


// case delete item ************************************************************

if ($mode == 'delete') {
    if ($type=='text') {
        $url = archive_delete_text($id);
    } elseif ($type=='address') {
        $url = archive_delete_address($id,$parent);
    } elseif ($type=='related') {
        $url = archive_delete_related($id,$parent);
    } else {
        $url = archive_delete_archive($id,$parent);
    }
    echo COM_Refresh ($url);


// case save item **************************************************************

} else if (($mode == $LANG_ADMIN['save']) && !empty ($LANG_ADMIN['save'])) {
    if ($type=='text') {
        $url = archive_save_text($_REQUEST);
    } elseif ($type=='address') {
        $url = archive_save_address($_REQUEST);
    } elseif ($type=='related') {
        $url = archive_save_related($_REQUEST);
    } else {
        $url = archive_save_archive($_REQUEST);
    }
    echo COM_Refresh ($url);


// case edit item **************************************************************

} else if ($mode == 'edit') {
    $display .= COM_siteHeader ($_AR_CONF['show_left_menu'], $LANG_AR[1]);
    if ($type=='text') {
        $display .= archive_edit_text($parent,$id);
    } elseif ($type=='address') {
        $display .= archive_edit_address($parent,$id);
    } elseif ($type=='related') {
        $display .= archive_edit_related($parent,$plugin,$id);
    } else {
        $display .= archive_edit_archive($parent,$id);
    }
    $display .= COM_siteFooter ();


// 'cancel' or no mode at all **************************************************

} else {
    $display .= COM_siteHeader ($_AR_CONF['show_left_menu'], $LANG_AR_ADMIN[11]);
    if ($msg > 0) {
        $display .= COM_showMessage ($msg, 'archive');
    }
    if (!empty($id)) {
        // We have an ID, so show that archive item
        $display .= archive_show_archive($id);
    } else {
        // No ID, so just list archives
        $display .= archive_list_items();
    }
    $display .= COM_siteFooter ();
}


// display page ****************************************************************

echo $display;


?>